KNearestFuzzyClassifier (Lucene 10.5.0 classification API)
Description: declaration: package: org.apache.lucene.classification, class: KNearestFuzzyClassifier

Package org.apache.lucene.classification

# Class KNearestFuzzyClassifier

java.lang.Object
org.apache.lucene.classification.KNearestFuzzyClassifier

All Implemented Interfaces:
  `Classifier<BytesRef>`

public class KNearestFuzzyClassifier extends Object implements Classifier<BytesRef>
A k-Nearest Neighbor classifier based on `NearestFuzzyQuery`.

WARNING: This API is experimental and might change in incompatible ways in the next release.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `KNearestFuzzyClassifier(IndexReader indexReader, Similarity similarity, Analyzer analyzer, Query query, int k, String classFieldName, String... textFieldNames)`
  Creates a `KNearestFuzzyClassifier`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ClassificationResult<BytesRef>`
  `assignClass(String text)`
  Assign a class (with score) to the given text String
  `List<ClassificationResult<BytesRef>>`
  `getClasses(String text)`
  Get all the classes (sorted by score, descending) assigned to the given text String.
  `List<ClassificationResult<BytesRef>>`
  `getClasses(String text, int max)`
  Get the first `max` classes (sorted by score, descending) assigned to the given text String.
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### KNearestFuzzyClassifier

    public KNearestFuzzyClassifier(IndexReader indexReader, Similarity similarity, Analyzer analyzer, Query query, int k, String classFieldName, String... textFieldNames)
    Creates a `KNearestFuzzyClassifier`.
    Parameters:
      `indexReader` - the reader on the index to be used for classification
      `similarity` - the `Similarity` to be used by the underlying `IndexSearcher` or `null` (defaults to `BM25Similarity`)
      `analyzer` - an `Analyzer` used to analyze unseen text
      `query` - a `Query` to eventually filter the docs used for training the classifier, or `null` if all the indexed docs should be used
      `k` - the no. of docs to select in the MLT results to find the nearest neighbor
      `classFieldName` - the name of the field used as the output for the classifier
      `textFieldNames` - the name of the fields used as the inputs for the classifier, they can contain boosting indication e.g. title^10

- ## Method Details

  - ### assignClass

    public ClassificationResult<BytesRef> assignClass(String text) throws IOException
    Description copied from interface: `Classifier`
    Assign a class (with score) to the given text String
    Specified by:
      `assignClass` in interface `Classifier<BytesRef>`
    Parameters:
      `text` - a String containing text to be classified
    Returns:
      a `ClassificationResult` holding assigned class of type `T` and score
    Throws:
      `IOException` - If there is a low-level I/O error.

  - ### getClasses

    public List<ClassificationResult<BytesRef>> getClasses(String text) throws IOException
    Description copied from interface: `Classifier`
    Get all the classes (sorted by score, descending) assigned to the given text String.
    Specified by:
      `getClasses` in interface `Classifier<BytesRef>`
    Parameters:
      `text` - a String containing text to be classified
    Returns:
      the whole list of `ClassificationResult`, the classes and scores. Returns `null` if the classifier can't make lists.
    Throws:
      `IOException` - If there is a low-level I/O error.

  - ### getClasses

    public List<ClassificationResult<BytesRef>> getClasses(String text, int max) throws IOException
    Description copied from interface: `Classifier`
    Get the first `max` classes (sorted by score, descending) assigned to the given text String.
    Specified by:
      `getClasses` in interface `Classifier<BytesRef>`
    Parameters:
      `text` - a String containing text to be classified
      `max` - the number of return list elements
    Returns:
      the whole list of `ClassificationResult`, the classes and scores. Cut for "max" number of elements. Returns `null` if the classifier can't make lists.
    Throws:
      `IOException` - If there is a low-level I/O error.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`